
#include <windows.h>
#include "chtimer.h"
#include "timetest.h"

HANDLE hPgmInstance ;

#define IDM_CHTIMEREVENT 0x3000


void CenterWindow(HWND hWnd)
    {
    int xSize, ySize, xPos, yPos ;
    RECT rc ;

    xSize = GetSystemMetrics(SM_CXSCREEN) ;
    ySize = GetSystemMetrics(SM_CYSCREEN) ;
    GetWindowRect(hWnd, &rc) ;
    xPos = (xSize - (rc.right - rc.left)) / 2 ;
    yPos = (ySize - (rc.bottom - rc.top)) / 2 ;
    SetWindowPos(hWnd, NULL, xPos, yPos, 0, 0,
		SWP_DRAWFRAME | SWP_NOSIZE | SWP_NOZORDER) ;
    }


LRESULT _loadds FAR PASCAL MainDlgProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
    static WORD wCountTotal = 0;
    WORD wCount ;

    lParam = lParam ;

    switch (msg)
	{
	case WM_INITDIALOG:
	    RemoveMenu(GetSystemMenu(hwndDlg,0),SC_CLOSE,MF_BYCOMMAND) ;
	    TimerStart(hwndDlg, IDM_CHTIMEREVENT) ;
	    break ;

	case WM_SHOWWINDOW:
	    if (wParam)
		CenterWindow(hwndDlg) ;
	    break ;

	case WM_COMMAND:
	    switch(wParam)
		{
		case IDM_CHTIMEREVENT:
		    wCount = TimerGetCount() ;
		    while (wCount)
			{
			wCountTotal += wCount ;
			wCount = TimerGetCount() ;
			}
		    SetDlgItemInt(hwndDlg, IDM_COUNT, wCountTotal, FALSE) ;
		    break ;

		case IDCANCEL:
		    EndDialog(hwndDlg, 0) ;
		    break ;
		}
	    break ;

	default:
	    return FALSE ;
	}

    return TRUE ;
}



int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    hPgmInstance = hInstance ;
    hPrevInstance = hPrevInstance ;
    lpCmdLine = lpCmdLine ;
    nCmdShow = nCmdShow ;

    if (!hPrevInstance)
	{
	if (MessageBox(0, "Press OK to start timer", "Timer Test", MB_OKCANCEL|MB_APPLMODAL) == IDOK)
	    {
	    DialogBox(hPgmInstance, "MainDlg", 0, (FARPROC) MainDlgProc) ;
	    TimerStop() ;
	    }
	}
    else
	MessageBox(0, "Another instance already running", "Timer Test", MB_ICONEXCLAMATION|MB_OK|MB_APPLMODAL) ;

    return 0 ;
}
