PAGE ,132
title VxD1.ASM - Example Device Driver #1
;EM	VxD1 - Example Device Driver #1
;
;	Copyright 1992, Cherry Hill Software
;	All rights reserved.
;
;	SUMMARY
;
;	WARNINGS
;
;
	.386p


.xlist
include vmm.inc
include debug.inc
include v86mmgr.inc
.list

VM_Not_Executable equ VM_Not_Executeable ; acckk!

subttl	VxD Declaration/Definition
page

VxD1_Init_Order equ VNETBIOS_Init_Order+100 ; Do this after the Virtual net
VxD1_Device_ID equ Undefined_Device_ID

Declare_Virtual_Device VXD1, 1, 0, VxD1_Control, VxD1_Device_ID, \
		       VxD1_Init_Order, \
		       VxD1_V86_Svc_Call,VxD1_PM_Svc_Call


TraceProc macro n	    ; Output a message stating the entered proc name
BeginProc n
	Trace_Out   "Entering &n (EBX=#ebx)"
	clc
	ret
EndProc n
endm




subttl Dispatch VxD Control
page
VxD_LOCKED_CODE_SEG

TraceProc VxD1_Sys_VM_Init
TraceProc VxD1_Create_VM
TraceProc VxD1_VM_Critical_Init
TraceProc VxD1_VM_Init
TraceProc VxD1_VM_Suspend
TraceProc VxD1_VM_Resume
;TraceProc VxD1_Set_Device_Focus ; we have a special msg for this one below
TraceProc VxD1_Begin_Message_Mode
TraceProc VxD1_End_Message_Mode
TraceProc VxD1_Reboot_Processor
TraceProc VxD1_Query_Destroy
TraceProc VxD1_Begin_PM_App	; For DOS-extender apps
TraceProc VxD1_End_PM_App	; "    "   "        "
TraceProc VxD1_Sys_VM_Terminate
TraceProc VxD1_VM_Terminate
TraceProc VxD1_VM_Not_Executable
TraceProc VxD1_Destroy_VM
TraceProc VxD1_System_Exit
TraceProc VxD1_Sys_Critical_Exit

TraceProc VxD1_PM_Svc_Call
TraceProc VxD1_V86_Svc_Call


ifdef DEBUG
TraceProc VxD1_Debug_Query
endif


BeginProc VxD1_Set_Device_Focus
	Trace_Out   "Entering VxD1_Set_Device_Focus (EBX=#ebx,EDX=#edx)"
	clc
	ret
EndProc VxD1_Set_Device_Focus


;
;   VxD1_Control
;

CtlDisp macro x
 Control_Dispatch x, VxD1_&x
 endm

Begin_Control_Dispatch VxD1
	Trace_Out   "ctl=#al"
	CtlDisp Sys_Critical_Init
	CtlDisp Device_Init
	CtlDisp Init_Complete
	CtlDisp Sys_VM_Init
	CtlDisp Create_VM
	CtlDisp VM_Critical_Init
	CtlDisp VM_Init
	CtlDisp VM_Suspend
	CtlDisp VM_Resume
	CtlDisp Set_Device_Focus
	CtlDisp Begin_Message_Mode
	CtlDisp End_Message_Mode
	CtlDisp Reboot_Processor
	CtlDisp Query_Destroy
	CtlDisp Begin_PM_App
	CtlDisp End_PM_App
	CtlDisp Sys_VM_Terminate
	CtlDisp VM_Terminate
	CtlDisp VM_Not_Executable
	CtlDisp Destroy_VM
	CtlDisp System_Exit
	CtlDisp Sys_Critical_Exit
ifdef DEBUG
	CtlDisp Debug_Query
endif
End_Control_Dispatch VxD1

VxD_LOCKED_CODE_ENDS



VxD_CODE_SEG
VxD_CODE_ENDS


subttl	Initialization Data
page
VxD_IDATA_SEG
; put initialization-only data here
VxD_IDATA_ENDS



subttl	Resident Data
page
VxD_DATA_SEG

VxD_DATA_ENDS


subttl	VxD Initialization
page
VxD_ICODE_SEG

;EP	VxD1_Sys_Critical_Init - VxD Initialization
;
;	ENTRY
;	    EBP - Client frame
;	    EBX - System VM handle
;	    DS,ES - FLAT
;
;	EXIT
;	    SUCCESS
;		Carry clear
;	    FAILURE
;		Carry set
;
;	WARNINGS
;
;	NOTES
;
;	CALLS
;

TraceProc VxD1_Sys_Critical_Init	; These go in the init object
TraceProc VxD1_Device_Init		; which is discarded after
TraceProc VxD1_Init_Complete		; Windows finishes initializing

VxD_ICODE_ENDS


VxD_REAL_INIT_SEG

VxD1_Real_Init LABEL FAR ; Called before Windows enters protected mode
	int 1
	mov ax,Device_Load_Ok	; Allow the VxD to load
	xor bx,bx		; No EMM Exclude pages
	xor si,si		; no instance data items
				; pass edx unmodified
	ret

VxD_REAL_INIT_ENDS

	END VxD1_Real_Init
